
#include "stdafx.h"
#include "NMImgRadioButton.h"

#define IMGRADIO_TEXT_INTERVAL 8     //̹ Ʈ  

CBitmap CNMImgRadioButton::m_bmpNormal;
CBitmap CNMImgRadioButton::m_bmpChecked;
bool CNMImgRadioButton::m_bHasAlphaChannel=false;

IMPLEMENT_DYNAMIC(CNMImgRadioButton, CButton)

CNMImgRadioButton::CNMImgRadioButton()
{
	m_nCheckState=BST_UNCHECKED;

	m_bBkColor=false;
	m_crBack=RGB(255,255,255);
	m_crText=RGB(0,0,0);
}

CNMImgRadioButton::~CNMImgRadioButton()
{
	m_bmpBkgnd.DeleteObject();
	m_bmpRadio.DeleteObject();
	m_bmpSelect.DeleteObject();
}

BEGIN_MESSAGE_MAP(CNMImgRadioButton, CButton)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_UPDATEUISTATE()
END_MESSAGE_MAP()

int CNMImgRadioButton::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CButton::OnCreate(lpCreateStruct) == -1)
		return -1;

	InitControl();

	return 0;
}

void CNMImgRadioButton::PreSubclassWindow()
{
	InitControl();

	CButton::PreSubclassWindow();
}

void CNMImgRadioButton::InitControl()
{
	ModifyStyle(0,BS_AUTORADIOBUTTON);

	if(m_bmpNormal.GetSafeHandle() && m_bmpChecked.GetSafeHandle())
	{
		BITMAP bmInfoNormal,bmInfoChecked;
		m_bmpNormal.GetBitmap(&bmInfoNormal);
		m_bmpChecked.GetBitmap(&bmInfoChecked);

		int nWidth = max(bmInfoNormal.bmWidth,bmInfoChecked.bmWidth);
		int nHeight = max(bmInfoNormal.bmHeight,bmInfoChecked.bmHeight);

		CString strText;
		GetWindowText(strText);

		if(!strText.IsEmpty())
		{
            CRect rcText(0, 0, 0, 0);

			CDC* pDC = GetDC();
			NMMemDC dcMem;
			dcMem.CreateCompatibleDC(pDC,1000,1000);
			dcMem.SelectObject(GetFont());
			dcMem.DrawText(strText,rcText,DT_LEFT|DT_SINGLELINE|DT_CALCRECT|DT_NOPREFIX);
			dcMem.DeleteDC();
			ReleaseDC(pDC);

			nWidth += IMGRADIO_TEXT_INTERVAL + rcText.Width();
		}

		SetWindowPos(0,0,0,nWidth,nHeight,SWP_NOZORDER|SWP_NOMOVE);
	}
}

void CNMImgRadioButton::PostNcDestroy()
{
	CButton::PostNcDestroy();
}

void CNMImgRadioButton::LoadUnitedImages(LPCTSTR pszPath)
{
	CString strUnitedImage=pszPath;

	ChangeToWorkingDirectory(strUnitedImage);

	CString strExtName=strUnitedImage.Mid(strUnitedImage.ReverseFind(_T('.'))+1);
	strExtName.MakeUpper();

	CImage Image;
	if(strExtName == _T("PNG"))
	{
		if(Image.Load(strUnitedImage)!=S_OK)
		{
			return;
		}

		if(Image.GetBPP() == 32)
		{
			m_bHasAlphaChannel=true;
			MultiplyAlpha(Image);
		}

		CDC* pDC=CDC::FromHandle(::GetDC(NULL));

		CDC dc;
		dc.CreateCompatibleDC(pDC);

		int nWidth=Image.GetWidth()/2;
		int nHeight=Image.GetHeight();

		if(m_bHasAlphaChannel)
		{
			NMMemDC dcMemNormal;
			dcMemNormal.CreateCompatibleDC(pDC, nWidth, nHeight ,true);

			m_bmpNormal.DeleteObject();
			m_bmpNormal.Attach(dcMemNormal.DetachBitmap());
			Image.Draw(dcMemNormal.m_hDC, 0, 0, nWidth, nHeight, 0, 0, nWidth, nHeight);

			NMMemDC dcMemChecked;
			dcMemChecked.CreateCompatibleDC(pDC, nWidth, nHeight ,true);

			m_bmpChecked.DeleteObject();
			m_bmpChecked.Attach(dcMemChecked.DetachBitmap());
			Image.Draw(dcMemChecked.m_hDC, 0, 0, nWidth, nHeight, nWidth, 0, nWidth, nHeight);
		}
		else
		{
			m_bmpNormal.DeleteObject();
			m_bmpChecked.DeleteObject();

			CBitmap bmpUnitedImage;

			LoadBitmapFromPath(bmpUnitedImage,strUnitedImage);

			GetIndexBitmapFromImage(m_bmpNormal,bmpUnitedImage,0,2);
			GetIndexBitmapFromImage(m_bmpChecked,bmpUnitedImage,1,2);
		}

		::ReleaseDC(NULL,pDC->GetSafeHdc());
	}
	else
	{
		m_bmpNormal.DeleteObject();
		m_bmpChecked.DeleteObject();
		CBitmap bmpUnitedImage;
		LoadBitmapFromPath(bmpUnitedImage,strUnitedImage);
		GetIndexBitmapFromImage(m_bmpNormal,bmpUnitedImage,0,2);
		GetIndexBitmapFromImage(m_bmpChecked,bmpUnitedImage,1,2);
	}
}

void CNMImgRadioButton::LoadBitmaps(LPCTSTR pszBkgnd,LPCTSTR pszRadio,LPCTSTR pszSelect)
{
	LoadBitmapFromPath(m_bmpBkgnd,pszBkgnd);
	LoadBitmapFromPath(m_bmpRadio,pszRadio);
	LoadBitmapFromPath(m_bmpSelect,pszSelect);

	if(m_bmpBkgnd.GetSafeHandle())
	{
        BITMAP bmInfo = {0};
		m_bmpBkgnd.GetBitmap(&bmInfo);

        CRect rcWindow(0, 0, 0, 0);
		GetWindowRect(rcWindow);
		GetParent()->ScreenToClient(rcWindow);
		MoveWindow(rcWindow.left,rcWindow.top,bmInfo.bmWidth,bmInfo.bmHeight);
	}
	else
	{
		CDC* dc = GetDC();      //Ʈ ̹ ̿ؼ ũ ٽ 
		CString strText;
        BITMAP bmInfo = {0};
        CRect rcNew(0, 0, 0, 0);
		rcNew.SetRectEmpty();

		GetWindowText(strText);

		m_bmpRadio.GetBitmap(&bmInfo);
		dc->DrawText( strText, &rcNew, DT_CALCRECT |DT_NOPREFIX);
		if( rcNew.Height() < bmInfo.bmHeight ) 
			rcNew.bottom = bmInfo.bmHeight;
		rcNew.InflateRect( 0, 0, bmInfo.bmWidth + IMGRADIO_TEXT_INTERVAL, 0 );      //̸ ÷ش
		MoveWindow( rcNew );

		ReleaseDC(dc);
	}
}

void CNMImgRadioButton::OnPaint()
{
	CPaintDC dc(this);

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(rcClient);

	NMMemDC dcMem;
	dcMem.CreateCompatibleDC(&dc,rcClient.Width(),rcClient.Height());

	CBrush brMask;
	brMask.CreateSolidBrush(RGB(255,0,255));
	dcMem.SelectObject(&brMask);
	dcMem.FillRect(rcClient,&brMask);
	brMask.DeleteObject();

	CDC dcBmp;
	dcBmp.CreateCompatibleDC(&dcMem);

	// ĥϱ
	if(m_bmpBkgnd.GetSafeHandle())
	{   //̹
		dcBmp.SelectObject(&m_bmpBkgnd);
		::TransparentBlt(dcMem.m_hDC,0,0,rcClient.Width(),rcClient.Height(),
			dcBmp.m_hDC,0,0,rcClient.Height(),rcClient.Height(),RGB(255,0,255));
	}
	else if(m_bBkColor)
	{   //COLOR
		CBrush brBack;
		brBack.CreateSolidBrush(m_crBack);
		dcMem.SelectObject(&brBack);
		dcMem.FillRect(rcClient,&brBack);
		brBack.DeleteObject();
	}
	else
	{   //θ ׸ (ó)
		CWnd* pParent=GetParent();
		CRect rcParent(0, 0, 0, 0);
		pParent->GetWindowRect(rcParent);

		NMMemDC dcParentBkgnd;
		dcParentBkgnd.CreateCompatibleDC(&dc,rcParent.Width(),rcParent.Height());
		LRESULT result=pParent->SendMessage(WM_ERASEBKGND,(WPARAM)dcParentBkgnd.m_hDC,0);

		CRect rcClient(0, 0, 0, 0);
		GetClientRect(rcClient);

		CRect rcRectInParent=rcClient;
		ClientToScreen(rcRectInParent);
		pParent->ScreenToClient(rcRectInParent);

		dcMem.BitBlt(0,0,rcClient.Width(),rcClient.Height(),
			&dcParentBkgnd,rcRectInParent.left,rcRectInParent.top,SRCCOPY);
	}

	//radio
	int nRadioWidth=0;
	if(m_bmpNormal.GetSafeHandle() && m_bmpChecked.GetSafeHandle())
	{
		//check
		if(GetCheck() == BST_CHECKED)
		{
			BITMAP bmInfo;
			m_bmpChecked.GetBitmap(&bmInfo);
			nRadioWidth = max(nRadioWidth,bmInfo.bmWidth);
			dcBmp.SelectObject(&m_bmpChecked);
			if(m_bHasAlphaChannel)
			{
				BLENDFUNCTION stBlend = { AC_SRC_OVER, 0, 255, AC_SRC_ALPHA };
				dcMem.AlphaBlend(0,0,bmInfo.bmWidth,bmInfo.bmHeight,
					&dcBmp,0,0,bmInfo.bmWidth,bmInfo.bmHeight,stBlend);
			}
			else
			{
				::TransparentBlt(dcMem.m_hDC,0,0,bmInfo.bmWidth,bmInfo.bmHeight,
					dcBmp.m_hDC,0,0,bmInfo.bmWidth,bmInfo.bmHeight,RGB(0,0,0));
			}
		}
		else
		{
			BITMAP bmInfo;
			m_bmpNormal.GetBitmap(&bmInfo);
			nRadioWidth = max(nRadioWidth,bmInfo.bmWidth);
			dcBmp.SelectObject(&m_bmpNormal);
			if(m_bHasAlphaChannel)
			{
				BLENDFUNCTION stBlend = { AC_SRC_OVER, 0, 255, AC_SRC_ALPHA };
				dcMem.AlphaBlend(0,0,bmInfo.bmWidth,bmInfo.bmHeight,
					&dcBmp,0,0,bmInfo.bmWidth,bmInfo.bmHeight,stBlend);
			}
			else
			{
				::TransparentBlt(dcMem.m_hDC,0,0,bmInfo.bmWidth,bmInfo.bmHeight,
					dcBmp.m_hDC,0,0,bmInfo.bmWidth,bmInfo.bmHeight,RGB(0,0,0));
			}
		}
	}
	else
	{
		if(m_bmpRadio.GetSafeHandle())
		{  
			BITMAP bmInfo;
			m_bmpRadio.GetBitmap(&bmInfo);
			dcBmp.SelectObject(&m_bmpRadio);
			if(m_bHasAlphaChannel)
			{
				BLENDFUNCTION stBlend = { AC_SRC_OVER, 0, 255, AC_SRC_ALPHA };
				dcMem.AlphaBlend(0,0,bmInfo.bmWidth,rcClient.Height(),
					&dcBmp,0,0,bmInfo.bmWidth,bmInfo.bmHeight,stBlend);
			}
			else
			{
				int nTop = rcClient.top + (rcClient.Height() - bmInfo.bmHeight) / 2;
				::TransparentBlt(dcMem.m_hDC,0,nTop,bmInfo.bmWidth,bmInfo.bmHeight,
					dcBmp.m_hDC,0,0,bmInfo.bmWidth,bmInfo.bmHeight,RGB(0,0,0));
			}

			nRadioWidth=bmInfo.bmWidth;

			//check
			if(GetCheck() == BST_CHECKED)
			{
				if(m_bmpSelect.GetSafeHandle())
				{   //̹
					BITMAP bmInfo;
					m_bmpSelect.GetBitmap(&bmInfo);
					dcBmp.SelectObject(&m_bmpSelect);
					if(m_bHasAlphaChannel)
					{
						BLENDFUNCTION stBlend = { AC_SRC_OVER, 0, 255, AC_SRC_ALPHA };
						dcMem.AlphaBlend(0,0,bmInfo.bmWidth,rcClient.Height(),
							&dcBmp,0,0,bmInfo.bmWidth,bmInfo.bmHeight,stBlend);
					}
					else
					{
						int nTop = rcClient.top + (rcClient.Height() - bmInfo.bmHeight) / 2;
						::TransparentBlt(dcMem.m_hDC,0,nTop,bmInfo.bmWidth,bmInfo.bmHeight,
							dcBmp.m_hDC,0,0,bmInfo.bmWidth,bmInfo.bmHeight,RGB(0,0,0));
					}
				}
				else
				{   //Text
					dcMem.SetBkMode(TRANSPARENT);
					dcMem.DrawText(_T("X"),CRect(0,0,rcClient.Height(),rcClient.Height()),
						DT_CENTER|DT_VCENTER|DT_SINGLELINE);
				}
			}
		}
		else
		{
			CRect rcRadio=CRect(CPoint(0,(rcClient.Height()-13)/2),CSize(13,13));
			nRadioWidth=rcRadio.Width();
			if(GetCheck() == BST_CHECKED)
			{
				DrawFrameControl(dcMem.m_hDC,rcRadio,DFC_BUTTON,DFCS_BUTTONRADIO|DFCS_CHECKED);
			}
			else
			{
				DrawFrameControl(dcMem.m_hDC,rcRadio,DFC_BUTTON,DFCS_BUTTONRADIO);
			}
		}
	}


	//Text
	CString strText;
	GetWindowText(strText);

	dcMem.SetBkMode(TRANSPARENT);

	dcMem.SelectObject(GetFont());
	if( IsWindowEnabled() )
		dcMem.SetTextColor(m_crText);
	else
		dcMem.SetTextColor(GetSysColor(COLOR_GRAYTEXT));

	dcMem.DrawText(strText,CRect(nRadioWidth+IMGRADIO_TEXT_INTERVAL,0,
		rcClient.Width(),rcClient.Height()), DT_LEFT|DT_VCENTER|DT_SINGLELINE|DT_NOPREFIX); 

	::TransparentBlt(dc.m_hDC,0,0,rcClient.Width(),rcClient.Height(),
		dcMem.m_hDC,0,0,rcClient.Width(),rcClient.Height(),RGB(0,0,0));
}

void CNMImgRadioButton::SetBkColor(COLORREF crBack)
{
	m_bBkColor=true;
	m_crBack=crBack;
}

BOOL CNMImgRadioButton::EnableWindow(BOOL bEnable)
{
	SetRedraw(FALSE);
	BOOL bReturn=CButton::EnableWindow(bEnable);
	SetRedraw(TRUE);

	CRect rcWindow(0, 0, 0, 0);
	GetWindowRect(rcWindow);
	GetParent()->ScreenToClient(rcWindow);
	GetParent()->InvalidateRect(rcWindow,FALSE);
	Invalidate();

	return bReturn;
}

void CNMImgRadioButton::SetTextColor(COLORREF crText)
{
	m_crText=crText;
	Invalidate();
}

void CNMImgRadioButton::OnUpdateUIState(UINT /*nAction*/, UINT /*nUIElement*/)
{
	Invalidate(FALSE);
}
